import * as React from 'react';
import { Route, Routes, Navigate, useLocation, useCurrentPath } from '../router/router-dom';
import { default as PageRender } from './index';
import { getComponentSchema } from '../utils/adapter/generate';
import { NotFound } from './status';
import { generatePageRelativePath } from '../utils/common';
export function PackageRender({ cals, componentsInfoMap, lowcodeModuleMap, historyOption, generateComponentsMap, generateActionsMap, onPageMounted, pageOptions, onRender, initDataContext, renderLoading, onNotFound, }) {
    var _a;
    const { items } = cals;
    const home = React.useMemo(() => {
        return (items || []).find((item) => item.id === cals.main);
    }, [items, cals.main]);
    const path = useCurrentPath();
    return (React.createElement(Routes, null,
        home && (React.createElement(Route, { exact: true, path: `${path}/`, element: React.createElement(Navigate, { to: `.${generatePageRelativePath(home, historyOption === null || historyOption === void 0 ? void 0 : historyOption._indexPage)}`, replace: true }) })),
        items.map((page) => {
            const uuid = cals.extra.rootPath ? `${cals.extra.rootPath}/${page.id}` : page.id;
            return (React.createElement(Route, { key: page.id, path: `${path}${generatePageRelativePath(page, historyOption === null || historyOption === void 0 ? void 0 : historyOption._indexPage)}`, element: React.createElement(PageRender, { page: Object.assign(Object.assign({}, page), { uuid, packageName: cals.extra.rootPath }), generateComponentsMap: generateComponentsMap, generateActionsMap: generateActionsMap, generateLowcodeModule: () => {
                        return lowcodeModuleMap[uuid] || {};
                    }, generateContext: (ctx, page, options) => {
                        const { widgets, componentSchema, dataBinds } = getComponentSchema(ctx, page, componentsInfoMap, undefined, {
                            isComposite: false,
                            looseError: options.looseError,
                            processCssUnit: options.processCssUnit,
                            disablePageComponentInvoke: options.disablePageComponentInvoke,
                        });
                        return {
                            widgetContext: widgets,
                            componentSchema,
                            dataBinds,
                        };
                    }, onMounted: onPageMounted, onRender: onRender, initDataContext: initDataContext, options: pageOptions, renderLoading: renderLoading }) }));
        }),
        React.createElement(Route, { path: "*", element: React.createElement(NotFound, { disabled: (_a = cals === null || cals === void 0 ? void 0 : cals.extra) === null || _a === void 0 ? void 0 : _a.disabled, onNotFound: onNotFound }) })));
}
function MockPage() {
    const location = useLocation();
    return (React.createElement(React.Fragment, null,
        React.createElement("p", null, "subpackage path"),
        React.createElement("p", null, location.pathname)));
}
