import * as React from 'react';
import { IPlatformApp } from '@cloudbase/cals';
export declare function upsertFavicon(favicon: any, app: any, entryDoc?: Document): void;
export declare function injectExternals(runtime?: Window & typeof globalThis): void;
export declare function loadDependencies(data: {
    dependencies: any[];
    runtime?: Window;
} | any[], options?: {
    cache: boolean;
} | boolean): Promise<any>;
export declare const loadDependiences: typeof loadDependencies;
export declare function formatDependiencesMap(components: any, controls: any): {
    controlMap: any;
    componentsMap: {};
    componentActionsMap: {};
};
export declare function componentMetaFilter(meta: any): {
    name: any;
    title: any;
    platform: any;
    shortcut: any;
    previewOperation: any;
};
export declare function WrapComponentFieldWithPropsHook({ Field, isPlainProps, sourceKey, }: {
    Field: React.ForwardRefExoticComponent<any>;
    isPlainProps: boolean;
    sourceKey?: string;
}): React.ForwardRefExoticComponent<Pick<any, string | number | symbol> & React.RefAttributes<unknown>>;
export declare function loadExternalResources({ externalResources, runtime, }: {
    externalResources?: IPlatformApp['externalResources'];
    runtime?: Window;
}, options?: {
    cache?: boolean;
}): Promise<void>;
export declare function loadRuntimeDependencies(): Promise<{
    controlMap: {};
    componentsMap: {
        [x: string]: React.ForwardRefExoticComponent<Pick<any, string | number | symbol> & React.RefAttributes<unknown>>;
    };
    componentActionsMap: {};
}>;
export declare function loadMockDependencies(): Promise<{
    controlMap: {};
    componentsMap: {};
    componentActionsMap: {};
}>;
export declare function mergeDependencies(list: any): any;
export declare function isRepeaterWidget(w: {
    widgetType: string;
    getConfig: () => {
        componentType?: string;
    };
}, repeaterComponentName: string): boolean;
