// "react-router-dom": "^5.2.0",
import * as React from 'react';
import { Router, Switch, Route as _Route, Redirect, useLocation, useRouteMatch } from 'react-router-dom';
export { useLocation } from 'react-router-dom';

export function CustomRouter({
  basename,
  children,
  future,
  history,
}: {
  basename?: string;
  future?: any;
  history: any;
  children: React.ReactNode;
}) {
  return <Router history={history}>{children}</Router>;
}

export function Routes(props: { children: any }) {
  return <Switch>{props.children}</Switch>;
}

export function Route(props: { path: string; element?: React.ReactNode; Component?: any; exact?: any }) {
  const { path: _path, element, Component, exact } = props;

  let path = React.useMemo(() => {
    const matched = _path?.match?.(/(.*)\/\*$/);
    if (matched?.[1]) {
      return matched?.[1];
    }
    return _path === '*' ? undefined : _path;
  }, [_path]);

  return (
    <_Route exact={exact} path={path} render={Component}>
      {element}
    </_Route>
  );
}

export function Navigate({ to, replace }: { to: string; replace?: boolean }) {
  const location = useLocation();
  return (
    <Redirect
      to={{
        ...location,
        pathname: to,
      }}
    />
  );
}

export function useCurrentPath() {
  const { path } = useRouteMatch();
  return path;
}
/* <Router history={history}>
  <React.Suspense fallback={<Loading />}>
    <Switch>
      {home && (
        <Route
          path={`/${home.root || ''}`}
          exact
          render={({ location }) => {
            return (
              <Redirect
                to={{
                  ...location,
                  pathname: home.path,
                }}
              />
            );
          }}
        />
      )}
      {routes.map((route) => {
        // 采用 render 的方式 企业工作台内路由会有两次变化
        // 从而两次 render page 导致 widgets 引用异常
        // __POWERED_BY_QIANKUN__
        const Component = route.render;
        const adminPortal = simpleCheckAdminPortal();
        return (
          <Route key={route.path} path={route.path} render={adminPortal ? undefined : Component}>
            {adminPortal ? <Component /> : null}
          </Route>
        );
      })}
      <Route>{({ location }) => <NotFound path={location?.pathname} onNotFound={onNotFound} />}</Route>
    </Switch>
  </React.Suspense>
</Router>; */
